<template>
    <div class="container">
        <el-button style="float: right;" size="mini" @click="back">返回</el-button>
        <div class="title">{{ title }}</div>
        <div class="chartWrap">
            <div class="barChartBox" id="barChart" v-if="type == 1 || type == 2" />
            <div class="chartBox" id="chart" v-else />
        </div>
    </div>
</template>
  
<script>
import * as echarts from 'echarts';

  export default {
    name: 'GraphVisval',
    data() {
        return {
            type: '',
            title: '巡逻情况态势图（上勤人数）',
            data: null,
        };
    },
    computed: {},
    mounted() {
        this.init();
    },
    methods: {
        init() {
            // const val = JSON.parse(JSON.stringify([{"2025-06-09":"0"},{"2025-06-10":"0"},{"2025-06-11":"0"},{"2025-06-12":"0"},{"2025-06-13":"3"},{"2025-06-14":"0"},{"2025-06-15":"0"},{"2025-06-16":"0"}]));
            const { green, orange, red, type, title, data } = this.$route.query;
            this.type = type;
            if(title){
                this.title = title;
            }
            if(type==1 || type ==2){
                if(type ==1){
                    this.title = '警情态势图'
                }
                if(type ==2){
                    this.title = '日同比数据对比'
                }
                setTimeout(() => {
                    let myChart = echarts.init(document.getElementById('barChart'));
                    let option = {
                        xAxis: {
                        type: 'category',
                        data: Array.isArray(data) ? data.map(item => Object.keys(item)[0]) : []
                        },
                        yAxis: {
                        type: 'value'
                        },
                        series: [
                        {
                            data: Array.isArray(data) ? data.map(item => Object.values(item)[0]) : [],
                            type: 'line'
                        }
                        ]
                    };
                    myChart.setOption(option)
                }, 100)
            }else{
                let num = Number(green || 0) + Number(orange || 0) + Number(red || 0);
                let pieChart = echarts.init(document.getElementById('chart'));
                const option = {
                    title: {
                        text: '',
                        subtext: '',
                        left: 'center'
                    },
                    tooltip: {
                        trigger: 'item'
                    },
                    legend: {
                      orient: 'vertical',
                      left: 'left',
                      formatter: function (name) {
                            let data = option.series[0].data;
                            let total = 0;
                            let value = 0;
                            for (let i = 0; i < data.length; i++) {
                                total += data[i].value;
                                if (data[i].name === name) {
                                value = data[i].value;
                                }
                            }
                            // 返回使用 rich 文本样式的格式
                            return `${name}： ${value}（${(value/num).toFixed(4)*100}%）`;
                        },
                    },
                    series: [
                        {
                            name: '',
                            type: 'pie',
                            radius: '50%',
                            data: [
                                { value: green || 0, name: '绿色', itemStyle: { color: '#387802' } },
                                { value: orange || 0, name: '橙色', itemStyle: { color: '#c8b003' } },
                                { value: red || 0, name: '红色', itemStyle: { color: '#ce1c1c' } },
                            ],
                            emphasis: {
                                itemStyle: {
                                    shadowBlur: 10,
                                    shadowOffsetX: 0,
                                    shadowColor: 'rgba(0, 0, 0, 0.5)'
                                }
                            }
                        }
                    ]
                };
                pieChart.setOption(option);
            }
        },
        back() {
            window.open('about:blank','_self').close();
        }
    }
  }
</script>
  
<style lang="scss" scoped>
.container {
    padding: 16px;
    .title {
        font-size: 18px;
        font-weight: bold;
        margin: 32px 0 48px;
    }
    .chartWrap {
        display: flex;
        align-items: center;
        justify-content: center;
    }
    .chartBox {
        width: 400px;
        height: 400px;
    }
    .barChartBox {
        width: 600px;
        height: 400px;
        display: flex;
        align-items: center;
        justify-content: center;
    }
}
</style>
  